package com.citygis.cim.domain.controller.api;

import com.citygis.cim.api.TemplateApi;
import com.citygis.cim.api.dto.template.TemplateRequestDTO;
import com.citygis.cim.api.dto.template.TemplateResponseDTO;
import com.citygis.cim.domain.controller.co.template.TemplateQueryCO;
import com.citygis.cim.domain.controller.vo.template.TemplateListVO;
import com.citygis.cim.domain.factory.mapper.TemplateFactoryMapper;
import com.citygis.cim.domain.service.TemplateService;
import com.citygis.common.boot.struct.Result;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RestController;

import jakarta.annotation.Resource;
import java.util.List;

@RestController("TemplateApiController")
public class TemplateApiController implements TemplateApi {
    private static final Logger log = LoggerFactory.getLogger(TemplateApiController.class);

    @Resource
    private TemplateService templateService;

    @Override
    public Result<List<TemplateResponseDTO>> list(TemplateRequestDTO templateRequestDTO) {
        TemplateQueryCO templateQueryCO = TemplateFactoryMapper.INSTANCE.requestDTOToQueryCO(templateRequestDTO);
        List<TemplateListVO> templateListVOList = templateService.listTemplate(templateQueryCO);
        List<TemplateResponseDTO> result = TemplateFactoryMapper.INSTANCE.listVOListToResponseDTOList(templateListVOList);
        return Result.success(result);
    }
}
