package com.citygis.cim.domain.factory.mapper;

import com.citygis.cim.api.dto.template.TemplateRequestDTO;
import com.citygis.cim.api.dto.template.TemplateResponseDTO;
import com.citygis.cim.domain.controller.co.template.TemplateCO;
import com.citygis.cim.domain.controller.co.template.TemplateQueryCO;
import com.citygis.cim.domain.controller.vo.template.TemplateGetVO;
import com.citygis.cim.domain.controller.vo.template.TemplateListVO;
import com.citygis.cim.domain.controller.vo.template.TemplatePageVO;
import com.citygis.cim.domain.dao.po.TemplatePO;
import com.citygis.cim.domain.entities.template.TemplateEntity;
import com.citygis.cim.domain.entities.template.TemplateQueryEntity;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;

import java.util.List;

@Mapper
public interface TemplateFactoryMapper {
    TemplateFactoryMapper INSTANCE = Mappers.getMapper(TemplateFactoryMapper.class);

    List<TemplateEntity> poToEntities(List<TemplatePO> templatePOList);

    TemplateEntity poToEntity(TemplatePO templatePO);

    TemplatePO entityToPo(TemplateEntity templateEntity);

    TemplateEntity coToEntity(TemplateCO co);

    List<TemplatePageVO> poToPageVOList(List<TemplatePO> list);

    TemplateQueryEntity queryCOToQueryEntity(TemplateQueryCO co);

    List<TemplateListVO> entitiesToListVOList(List<TemplateEntity> templateEntities);

    TemplateGetVO entityToGetVO(TemplateEntity templateEntity);

    TemplateQueryCO requestDTOToQueryCO(TemplateRequestDTO templateRequestDTO);

    List<TemplateResponseDTO> listVOListToResponseDTOList(List<TemplateListVO> templateListVOList);

    TemplateResponseDTO listVOToResponseDTO(TemplateListVO templateListVO);
}
